###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.7 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import Products
import base_item
import mail_gateway
import mailbox
import message_container
import news_group_folder
import message_filter_folder
import gum_mailbox

gum_add_redirect = HTMLFile('gum_add_redirect', globals())
manage_add_gum_form = HTMLFile('gum_add', globals())


def manage_add_gum(self, id, local_username, title, REQUEST=None):
    "Add an instance of the gum class"

    self._setObject(id, gum(id, local_username, ''))

    if REQUEST is not None:

        return self.manage_main(self, REQUEST)


class gum(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'GUM'
	icon = 'misc_/GUM/Folder_icon.gif'
	#default_catalog = 'Catalog'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'local_username', 'type':'string'},
		)

	meta_types = (
		{'name':'MailGateway',
		 'action':'manage_add_mail_gateway_form'},
		{'name':'MessageContainer',
		 'action':'manage_add_message_container_form'},
		{'name':'NewsGroupFolder',
		 'action':'manage_add_news_group_folder_form'},
		{'name':'MessageFilterFolder',
		 'action':'manage_add_message_filter_folder_form'}
		)

	manage_add_mail_gateway_form = mail_gateway.manage_add_mail_gateway_form
	manage_add_mail_gateway = mail_gateway.manage_add_mail_gateway
	mail_gateway_add_redirect = mail_gateway.add_mail_gateway_redirect

	manage_add_message_container_form = message_container.manage_add_message_container_form
	manage_add_message_container = message_container.manage_add_message_container
	message_container_add_redirect = message_container.message_container_add_redirect

	manage_add_news_group_folder_form = news_group_folder.manage_add_news_group_folder_form
	manage_add_news_group_folder = news_group_folder.manage_add_news_group_folder
	news_group_folder_add_redirect = news_group_folder.news_group_folder_add_redirect

	manage_add_message_filter_folder_form = message_filter_folder.manage_add_message_filter_folder_form
	manage_add_message_filter_folder = message_filter_folder.manage_add_message_filter_folder
	message_filter_folder_add_redirect = message_filter_folder.message_filter_folder_add_redirect	

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add MailGateway',
		 ('manage_add_mail_gateway', 'manage_add_mail_gateway_form')),
		('Add MessageContainer',
		 ('manage_add_message_container', 'manage_add_message_container_form')),
		('View GUMs',
		 ('',)),
		)

	index_html = HTMLFile('gum_index', globals())


	def __init__(self, id, local_username, title=''):
		"Initialize the class instance"

		self.id = id
		self.title = title

		self.local_username = local_username
		
		self.index_object()


	def get_messages(self):
		"""Retrieves messages from the local server."""

		first_folder = self.objectValues('MessageContainer')[0]

		mbox = gum_mailbox.UnixMailbox(
			open('/var/spool/mail/'+self.local_username))

		while 1:

			message = mbox.next()

			return message

			if not message:

				break

			first_folder.manage_add_rfc822_message()

		"""
		message_filters = []

		for filter_folder in self.objectValues('MessageFilterFolder'):

			for message_filter in filterfolder.objectValues('MessageFilter'):

				message_filters.append(message_filter)


		while 1:

			message = mbox.next()

			if not message:

				break

			for message_filter in message_filters:

				if message.has_key(message_filter.header_name):

					# FIXME (add some logic)

					# message_filter._message_container._setobj

					pass
			"""

default__class_init__(gum)
